/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { "default": obj }; };

	var _import = __webpack_require__(1);

	var mod0 = _interopRequireWildcard(_import);

	var _import2 = __webpack_require__(2);

	var mod1 = _interopRequireWildcard(_import2);

	var _import3 = __webpack_require__(3);

	var mod2 = _interopRequireWildcard(_import3);

	var _import4 = __webpack_require__(4);

	var mod3 = _interopRequireWildcard(_import4);

	wrm.defineModule("wrm/comp/ListService", mod0);

	wrm.defineModule("wrm/comp/DetailsService", mod1);

	wrm.defineModule("wrm/comp/MapService", mod2);

	wrm.defineModule("wrm/comp/MapOperationService", mod3);

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	/**
	 * Service for List view components.
	 * 
	 * @constructor
	 * @extends wrm.core.AbstractCachedViewComponentService
	 */
	exports.default = wrm.defineService(wrm.core.AbstractCachedViewComponentService, {

	    /** @override */
	    initialize: function (descr) {
	        var thisService = this;

	        /**
	         * @private
	         * @type {!wrm.data.meta.Entity}
	         */
	        this._entity; // init'd below

	        /**
	         * @private
	         * @type {!wrm.data.Condition}
	         */
	        this._condExpr; // init'd below

	        /**
	         * @private
	         * @type {!boolean}
	         */
	        this._checkable = descr["checkable"] || false;

	        /**
	         * @private
	         * @type {boolean}
	         */
	        this._hasPreCondExpr = descr["preCondExprs"] !== undefined ? true : false;

	        /**
	         * @private
	         * @type {!wrm.data.Condition}
	         */
	        this._preCondExpr; // init'd below

	        /**
	         * @private
	         * @type {!number}
	         */
	        this._maxResults = descr["maxResults"];

	        /**
	         * @private
	         * @type {!boolean}
	         */
	        this._distinct = descr["distinct"] || false;

	        /**
	         * @private
	         * @type {!Object}
	         */
	        this._output; // init'd below

	        /**
	         * @private
	         * @type {!Object}
	         */
	        this._toBind; // init'd below

	        /**
	         * @private
	         * @type {!Array}
	         */
	        this._order = descr["order"];

	        /**
	         * @private
	         * @type {!wrm.data.DataService}
	         */
	        this._dataService; // init'd below

	        return this.getManager().getDataService().then(function (dataService) {
	            thisService._dataService = dataService;
	            thisService._entity = dataService.getMetadata().getEntity(descr["entity"]);
	            thisService._condExpr = thisService._dataService.prepareCondition(thisService._entity.getId(), descr["condExprs"]);
	            var output = descr["output"];
	            thisService._output = {};
	            thisService._toBind = {};
	            if (output.length !== 0) {
	                output.forEach(function (column) {
	                    thisService._output[column["viewName"]] = column["ref"];
	                    thisService._toBind[column["viewName"]] = column["bindName"];
	                });
	            }

	            if (thisService._checkable) {
	                var keyAttr = thisService._entity.getKeyAttribute();
	                thisService._output[keyAttr.getName()] = keyAttr.getId();
	                thisService._toBind[keyAttr.getName()] = keyAttr.getId();
	                thisService._preCondExpr = thisService._dataService.prepareCondition(thisService._entity.getId(), descr["preCondExprs"]);
	            }
	        });
	    },

	    /** @override */
	    createResult: function (context) {
	        var thisService = this;
	        var input = context.getInput();

	        var options = {
	            output: this._output,
	            distinct: this._distinct,
	            filter: this._condExpr,
	            order: this._order
	        };
	        var resultsLength = input["maxResults"] || thisService._maxResults;
	        if (resultsLength > 0) {
	            var limit = {
	                count: resultsLength
	            };
	            options["limit"] = limit;
	        }

	        var promises = [];

	        promises.push(this._retrieveData(input, options));
	        if (this._checkable) {
	            var keyAttributeId = this._entity.getKeyAttribute().getId();
	            if (!this._refreshCheckedObjects(context)) {
	                var checkedObj = [];
	                var checkedRows = context.getView()["checkedRows"];
	                Object.keys(checkedRows).forEach(function (rowKey) {
	                    if (checkedRows[rowKey]) {
	                        checkedObj.push(rowKey);
	                    }
	                });
	                promises.push(checkedObj);
	            } else if (this._hasPreCondExpr) {
	                var preCheckOptions = {
	                    output: keyAttributeId,
	                    filter: this._preCondExpr
	                };
	                promises.push(this._retrieveData(input, preCheckOptions));
	            }
	        }

	        return Promise.all(promises).then(function (results) {
	            var dataRows = results[0];
	            var preChecked = results[1] || [];
	            var checkedRows = {};

	            if (thisService._checkable) {
	                preChecked.forEach(function (objKey) {
	                    checkedRows[objKey] = true;
	                });
	            }

	            return {
	                "data": dataRows,
	                "checkedRows": checkedRows
	            };
	        }, function (e) {
	            console.error(e);
	        });
	    },

	    /**
	     * @private
	     * @param {!wrm.nav.Input} input
	     * @param {{ output: (!Object.<string,string>|!Array.<string>|string|undefined), distinct: (boolean|undefined), include: (!Array.<string>|string|undefined),
	     *            filter: (!wrm.data.Condition|!Object|undefined), order: (!Array.<{property:string,reverse:boolean}|string>|{property:string,reverse:boolean}|string|undefined),
	     *            limit: ({begin:number,count:number}|number|undefined) }=} options
	     * @return {!Promise.<Object>}
	     */
	    _retrieveData: function (input, options) {
	        var thisService = this;
	        return this._dataService.execute(function (d) {
	            return d.select(thisService._entity.getId(), options, input);
	        });
	    },

	    /** @override */
	    catchEvent: function (context, event) {
	        var rowIndex = event.getParameters()["position"];
	        var view = context.getView();
	        view["current"] = rowIndex;
	    },

	    /** @override */
	    computeOutputFromResult: function (context, result) {
	        return this._createOutput(result);
	    },

	    /** @override */
	    submitView: function (context) {
	        var view = context.getView();
	        return this._createOutput(view);
	    },

	    /**
	     * @param {!Object} view
	     * @return {!Object}
	     */
	    _createOutput: function (view) {
	        var output = {};
	        var data = view["data"];
	        var current = view["current"] || 0;
	        var dataSize = data.length;
	        if (dataSize > 0) {
	            if (current === dataSize) {
	                current--;
	            }
	            if (this._checkable) {
	                output["checkedKeys"] = [];
	                var checkedRows = view["checkedRows"];
	                Object.keys(checkedRows).forEach(function (row) {
	                    if (checkedRows[row] == true) {
	                        output["checkedKeys"].push(row);
	                    }
	                });
	            }

	            var toBind = this._toBind;
	            var currentRow = data[current];
	            var outputData = {};
	            Object.keys(this._output).forEach(function (key) {
	                outputData[toBind[key]] = currentRow[key];
	            });

	            output["data"] = outputData;
	        }
	        output["dataSize"] = dataSize;
	        return output;
	    },

	    /**
	     * @private
	     * @param {!wrm.core.ViewComponentContext} context
	     * @return {boolean}
	     */
	    _refreshCheckedObjects: function (context) {
	        var RefreshMode = wrm.core.RefreshMode;
	        var refreshMode = context.getFormRefreshMode();
	        if (refreshMode === RefreshMode.PRESERVE) {
	            return false;
	        } else {
	            return true;
	        }
	    } });
	module.exports = exports.default;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	/**
	 * Service for Details view components.
	 * 
	 * @constructor
	 * @extends wrm.core.AbstractCachedViewComponentService
	 */
	exports.default = wrm.defineService(wrm.core.AbstractCachedViewComponentService, {

	    /** @override */
	    initialize: function (descr) {
	        var thisService = this;

	        /**
	         * @private
	         * @type {!string}
	         */
	        this._entityId = descr["entity"];

	        /**
	         * @private
	         * @type {!Object}
	         */
	        this._output; // init'd below

	        /**
	         * @private
	         * @type {!Object}
	         */
	        this._toBind; // init'd below

	        /**
	         * @private
	         * @type {!wrm.data.Condition}
	         */
	        this._condExpr; // init'd below

	        /**
	         * @private
	         * @type {!wrm.data.DataService}
	         */
	        this._dataService; // init'd below

	        return this.getManager().getDataService().then(function (dataService) {
	            thisService._dataService = dataService;
	            thisService._condExpr = thisService._dataService.prepareCondition(thisService._entityId, descr["condExprs"]);
	            var output = descr["output"];
	            thisService._output = {};
	            thisService._toBind = {};
	            if (output.length !== 0) {
	                output.forEach(function (column) {
	                    thisService._output[column["viewName"]] = column["ref"];
	                    thisService._toBind[column["viewName"]] = column["bindName"];
	                });
	            }
	        });
	    },

	    /** @override */
	    createResult: function (context) {
	        var thisService = this;
	        var input = context.getInput();

	        var resultsPromise = this._dataService.execute(function (d) {
	            var options = {
	                output: thisService._output,
	                filter: thisService._condExpr
	            };
	            return d.selectOne(thisService._entityId, options, input);
	        });

	        return resultsPromise.then(function (row) {
	            return {
	                "data": row
	            };
	        }, function (e) {
	            console.error(e);
	        });
	    },

	    /** @override */
	    computeOutputFromResult: function (context, result) {
	        return this._createOutput(result["data"]);
	    },

	    /** @override */
	    submitView: function (context) {
	        return this._createOutput(context.getView()["data"]);
	    },

	    /**
	     * @private
	     * @param {!Object} data
	     * @returns {!Object}
	     */
	    _createOutput: function (data) {
	        var output = {};
	        if (data === null) {
	            output["dataSize"] = 0;
	        } else {
	            var toBind = this._toBind;
	            var outputData = {};
	            Object.keys(this._output).forEach(function (key) {
	                outputData[toBind[key]] = data[key];
	            });
	            output["data"] = outputData;
	            output["dataSize"] = 1;
	        }
	        return output;
	    } });
	module.exports = exports.default;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	/**
	 * Service for Map view component.
	 * 
	 * @constructor
	 * @extends wrm.core.AbstractViewComponentService
	 */
	exports.default = wrm.defineService(wrm.core.AbstractViewComponentService, {

	    /** @override */
	    initialize: function (descr) {},

	    /** @override */
	    computeOutput: function (context) {
	        var view = context.getView();
	        return this._createOutput(view);
	    },

	    /** @override */
	    catchEvent: function (context, event) {
	        var view = context.getView();
	        view["_markerIndex"] = event.getParameters()["position"];
	    },

	    /** @override */
	    submitView: function (context) {
	        var view = context.getView();
	        return this._createOutput(view);
	    },

	    /**
	     * @param {!Object} view
	     * @return {!Object}
	     */
	    _createOutput: function (view) {
	        var output = {};
	        var markers = view["_markers"];
	        var markerIndex = view["_markerIndex"];
	        for (var i = 0; i < markers.length; i++) {
	            if (markers[i].get("wrIndex") === markerIndex) {
	                output["locationIds"] = markers[i].get("locationId");
	                break;
	            }
	        }
	        return output;
	    },

	    /** @override */
	    updateView: function (context) {
	        var thisService = this;
	        var view = context.getView();
	        var input = context.getInput();
	        var promise = null;
	        var infoClickListener = null;

	        /* inizialize the map plugin */
	        if (view["_mapPromise"]) {
	            promise = view["_mapPromise"];
	        } else {
	            promise = this._initializeMap().then(function (map) {
	                view["map"] = map;
	                map["$destroy"] = function () {
	                    map.remove();
	                    delete view["map"];
	                    delete view["_mapPromise"];
	                    delete view["_markers"];
	                    delete view["_markersPromise"];
	                };
	                return map;
	            });
	            view["_mapPromise"] = promise;
	        }

	        /* inizialize the infoWindowClick */
	        if (view["infoWindowClick"]) {
	            infoClickListener = view["infoWindowClick"];
	        } else {
	            infoClickListener = new wrm.util.ListenerList();
	            view["infoWindowClick"] = infoClickListener;
	        }

	        var infoClickCallback = function (marker) {
	            infoClickListener.notifyAll(marker.get("wrIndex"));
	        };

	        return promise.then(function (map) {

	            if (!view["_markersPromise"]) {
	                view["_markersPromise"] = Promise.resolve();
	            }

	            view["_markersPromise"] = view["_markersPromise"].then(function () {

	                var markers = view["_markers"] || [];
	                if (view["_markers"] === undefined) {
	                    view["_markers"] = markers;
	                }

	                /* Retrieve old markers locationIds */
	                var markersId = [];
	                for (var i = 0; i < markers.length; i++) {
	                    markersId.push(markers[i].get("locationId"));
	                }

	                var newMarkersValues = thisService._computeMarkersValues(input);
	                var existingMarkers = [];
	                var mPromise = Promise.resolve();

	                newMarkersValues.forEach(function (markerValues, i) {
	                    var markerIndex = markersId.indexOf(markerValues["locationIds"]);
	                    if (markerIndex < 0) {
	                        // new marker
	                        mPromise = mPromise.then(function () {
	                            return thisService._createMarker(map, markerValues, i, infoClickCallback).then(function (marker) {
	                                markers.push(marker);
	                            });
	                        });
	                    } else {
	                        // existing marker
	                        existingMarkers.push(markerValues["locationIds"]);
	                        var marker = markers[markerIndex];
	                        mPromise = mPromise.then(function () {
	                            return thisService._updateMarker(marker, markerValues, i);
	                        });
	                    }
	                });

	                /* remove markers not present in the new data */
	                for (var i = 0; i < markersId.length; i++) {
	                    var locationId = markersId[i];
	                    if (existingMarkers.indexOf(locationId) < 0) {
	                        // not present in updated markers
	                        var markerIndex = -1;
	                        for (var y = 0; y < markers.length; y++) {
	                            if (markers[y].get("locationId") === locationId) {
	                                markerIndex = y;
	                                break;
	                            }
	                        }
	                        if (markerIndex >= 0) {
	                            var marker = markers[markerIndex];
	                            markers.splice(markerIndex, 1);
	                            thisService._removeMarker(marker);
	                        } else {}
	                    }
	                }

	                // center the map on the markers
	                return mPromise.then(function () {
	                    var positions = [];
	                    var positionPromises = Promise.resolve();
	                    // for (var i = 0; i < markers.length; i++) {
	                    markers.forEach(function (marker) {
	                        positionPromises = positionPromises.then(function () {
	                            return new Promise(function (resolve, reject) {
	                                marker.getPosition(function (pos) {
	                                    positions.push(pos);
	                                    resolve();
	                                });
	                            });
	                        });
	                    });

	                    return positionPromises.then(function () {
	                        if (positions.length === 1) {
	                            positions = positions[0];
	                        }
	                        map.moveCamera({
	                            "target": positions,
	                            "zoom": 14
	                        });
	                    });
	                });
	            });
	        });
	    },

	    /**
	      * @private
	      */
	    _initializeMap: function () {
	        var MAP_INIT_OPTIONS = {
	            "controls": {
	                "compass": false,
	                "myLocationButton": false,
	                "indoorPicker": false,
	                "zoom": false
	            },
	            "gestures": {
	                "scroll": true,
	                "tilt": false,
	                "rotate": false,
	                "zoom": true
	            }
	        };
	        return new Promise(function (resolve, reject) {
	            var map = plugin.google.maps.Map.getMap(MAP_INIT_OPTIONS);
	            map.on(plugin.google.maps.event.MAP_READY, function (map) {
	                map.clear();
	                resolve(map);
	            });
	        });
	    },

	    /**
	      * @private
	      */
	    _createMarker: function (map, markerValues, index, infoClickCallback) {
	        return this._retriveLatLng(markerValues).then(function (latLng) {
	            var markerInfo = {
	                "position": latLng,
	                "title": markerValues["titles"],
	                "snippet": markerValues["snippets"],
	                "locationId": markerValues["locationIds"],
	                "address": markerValues["addresses"],
	                "latitude": markerValues["latitudes"],
	                "longitude": markerValues["longitudes"],
	                "wrIndex": index,
	                "infoClick": infoClickCallback
	            };
	            return new Promise(function (resolve, reject) {
	                map.addMarker(markerInfo, function (result) {
	                    resolve(result);
	                });
	            });
	        });
	    },

	    /**
	      * @private
	      * @return {!Promise}
	      */
	    _retriveLatLng: function (markerValues) {
	        if (markerValues["addresses"]) {
	            return this._geocode(markerValues["addresses"]).then(function (position) {
	                return new plugin.google.maps.LatLng(position["lat"], position["lng"]);
	            });
	        } else if (markerValues["latitudes"] && markerValues["longitudes"]) {
	            return Promise.resolve(new plugin.google.maps.LatLng(markerValues["latitudes"], markerValues["longitudes"]));
	        } else {
	            throw new Error("Marker doesn't have valid address or valid latitude, longitude.");
	        }
	    },

	    /**
	      * @private
	      */
	    _updateMarker: function (marker, markerValues, index) {
	        if (marker.getTitle() !== markerValues["titles"]) {
	            marker.setTitle(markerValues["titles"]);
	        }
	        if (marker.getSnippet() !== markerValues["snippets"]) {
	            marker.setSnippet(markerValues["snippets"]);
	        }
	        if (marker.get("locationId") !== markerValues["locationIds"]) {
	            marker.set("locationId", markerValues["locationIds"]);
	        }
	        if (marker.get("wrIndex") !== index) {
	            marker.set("wrIndex", markerValues["wrIndex"]);
	        }

	        var positionChanged = false;
	        if (marker.get("address") !== markerValues["addresses"]) {
	            marker.set("address", markerValues["addresses"]);
	            positionChanged = true;
	        }
	        if (marker.get("latitude") !== markerValues["latitudes"]) {
	            marker.set("latitude", markerValues["latitudes"]);
	            positionChanged = true;
	        }
	        if (marker.get("longitude") !== markerValues["longitudes"]) {
	            marker.set("longitude", markerValues["longitudes"]);
	            positionChanged = true;
	        }
	        if (positionChanged) {
	            return this._retriveLatLng(markerValues).then(function (latLng) {
	                marker.setPosition(latLng);
	                return marker;
	            });
	        }

	        return Promise.resolve(marker);
	    },

	    /**
	      * @private
	      */
	    _removeMarker: function (marker) {
	        marker.remove();
	    },

	    /**
	      * @private
	      * @param {!String} address
	      * @return {!Array}
	      */
	    _geocode: function (address) {
	        var request = {
	            "address": address
	        };

	        return new Promise(function (resolve, reject) {
	            plugin.google.maps.Geocoder.geocode(request, function (results) {
	                if (results.length) {
	                    var result = results[0];
	                    var position = result.position;
	                    resolve(position);
	                } else {
	                    reject("Unable to geocode the address");
	                }
	            });
	        });
	    },

	    /**
	      * @private
	      * @param {!wrm.nav.Input} input
	      * @returns {!Array.<Object>}
	      */
	    _computeMarkersValues: function (input) {
	        var properties = ["addresses", "images", "latitudes", "locationIds", "longitudes", "snippets", "titles"];

	        var result = [];

	        /* Normalize input values, turning them in arrays of the same length */
	        var normalizedInput = {};
	        var maxLength = 0;
	        for (var i = 0; i < properties.length; i++) {
	            var property = properties[i];
	            var propertyInput = input[property];
	            if (propertyInput !== undefined) {
	                if (angular.isArray(propertyInput)) {
	                    if (maxLength === 0 || maxLength === 1) {
	                        maxLength = propertyInput.length;
	                    } else if (maxLength !== propertyInput.length) {
	                        throw new Error("Input array lengths do not match");
	                    }
	                } else {
	                    propertyInput = [propertyInput];
	                    maxLength = maxLength || 1;
	                }
	                normalizedInput[property] = propertyInput;
	            }
	        }

	        /*
	          * Collect properties at the same indexes into separate value-holding objects
	          */
	        if (maxLength) {
	            for (var k = 0; k < maxLength; k++) {
	                var tmpObj = {};
	                Object.keys(normalizedInput).forEach(function (propertyId) {
	                    if (normalizedInput[propertyId].length === 1) {
	                        tmpObj[propertyId] = normalizedInput[propertyId][0];
	                    } else {
	                        tmpObj[propertyId] = normalizedInput[propertyId][k];
	                    }
	                });
	                result.push(tmpObj);
	            }
	        }

	        return result;
	    } });
	module.exports = exports.default;

	// We didn't find the old marker!!! Something goes wrong!!!

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	/**
	 * Service for Map Operation operations.
	 * 
	 * @constructor
	 * @extends wrm.core.AbstractOperationService
	 */
	exports.default = wrm.defineService(wrm.core.AbstractOperationService, {

	    /** @override */
	    executeOperation: function (context) {

	        var thisService = this;
	        var input = context.getInput();

	        return Promise.resolve().then(function (value) {
	            plugin.google.maps.external.launchNavigation({
	                "from": input["sourceAddress"],
	                "to": input["destinationAddress"]
	            });
	            return new wrm.nav.Output("success");
	        }, function (value) {});
	    } });
	module.exports = exports.default;

	// never called

/***/ }
/******/ ]);